



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>DICOM医学图像处理：开源库mDCM与DCMTK的比較分析（一），JPEG无损压缩DCM图像</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">DICOM医学图像处理：开源库mDCM与DCMTK的比較分析（一），JPEG无损压缩DCM图像</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-22 23:35:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<h1>背景介绍：</h1>
<p>近期项目需求，须要使用C#进行最新的UI和相关DICOM3.0医学图像模块的开发。在C&#043;&#043;语言下，我使用的是应用最广泛的DCMTK开源库，在本专栏的起初阶段的大多数博文都是对DCMTK开源库的介绍和学习。眼下因为项目须要，现開始对mDCM开源库继续学习分析，因此本专栏接下来的文章会大多以mDCM开源库为例进行医学图像的解说，DCMTK因为是C&#043;&#043;语言开发的，所以作为我学习和剖析mDCM开源库的原始根据，我们并未放弃对DCMTK开源库的学习，而是通过更加细致的研读和分析DCMTK的C&#043;&#043;源代码，从而更好的切更迅速的切换到C#语言环境下的医学图像处理。</p>
<h1>DCMTK、mDCM（fo-dicom）的关系：</h1>
<p>DCMTK的官网上有具体的说明文档，对该开源库的各个类，以及类之间的依赖关系进行了清晰的阐述。是学习DICOM3.0医学最新标准不可或缺的资源。其官网网址是：<a href="http://www.dcmtk.org/" rel="external nofollow noreferrer">http://www.dcmtk.org/</a>，活跃的开发人员论坛地址是：<a href="http://forum.dcmtk.org/index.php" rel="external nofollow noreferrer">http://forum.dcmtk.org/index.php</a>。</p>
<p>mDCM眼下了解是从DCMTK开源库转过来的，或者说是该开源项目的还有一个分支，是对用C#语言对C&#043;&#043;版本号的医学图像开源库的再次组织和封装，其项目托管在GitHub上的官方网址是：<a href="https://github.com/rcd/mdcm" rel="external nofollow noreferrer">https://github.com/rcd/mdcm</a>。此处就须要提到fo-dicom了，该开源库是mDCM的升级版本号，里面添加了几大特性，详情可參见GitHub网址：<a href="https://github.com/rcd/fo-dicom" rel="external nofollow noreferrer">https://github.com/rcd/fo-dicom</a>。</p>
<p>大致上这三者的关系就是如此，所以更说明了我们依旧要以DCMTK开源库为根据，来高速学习和剖析mDCM（fo-dicom）开源库，要非常好的借助于DCMTK开源库丰富而具体的说明文档，以及活跃的开发人员论坛。以下我们就通过对DCM图像进行无损压缩这一任务来对照学习一下mDCM与DCMTK开源库的不同。</p>
<h1>DCMTK与mDCM对DCM图像进行JPEG无损压缩的对照学习：</h1>
<p>DCMTK的说明文档中对于dcmjpeg包的介绍中，就直接给出了一个利用JPEG无损压缩的实例。详细代码例如以下：</p>
<pre class="prettyprint linenums">/*****************************************************************************<br />
dcmjpeg程序包<br />
dcmjpeg提供了一个压缩/解压缩库以及可用工具。该模块包括一些类，可将DICOM图像对象在非压缩和JPEG压缩表示（传输协议）之间转换。无失真和有失真JPEG处理都被支持。这个模块实现了一族codec(编码解码器，由DcmCodec类派生而来)，能够将这些codec在codec list中注冊，codec list是由dcmdata模块保存的。<br />
主要接口类：<br />
--DJEncoderRegistration: 一个singleton（孤立）类，为全部支持的JPEG处理注冊编码器。在djencode.h中定义。<br />
--DJDecoderRegistration: 一个singleton（孤立）类，为全部支持的JPEG处理注冊解码器。在djdecode.h中定义。<br />
--DJCodecEncoder: JPEG编码器的一个抽象codec类。This abstract class contains most of the application logic needed for a dcmdata codec object that implements a JPEG encoder using the DJEncoder interface to the underlying JPEG implementation. This class only supports compression, it neither implements decoding nor transcoding. 在djcodece.h中定义。<br />
--DJCodecDecoder: JPEG解码器的一个抽象codec类。This abstract class contains most of the application logic needed for a dcmdata codec object that implements a JPEG decoder using the DJDecoder interface to the underlying JPEG implementation. This class only supports decompression, it neither implements encoding nor transcoding.<br />
工具：<br />
dcmcjpeg: Encode DICOM file to JPEG transfer syntax<br />
dcmdjpeg: Decode JPEG-compressed DICOM file<br />
dcmj2pnm: Convert DICOM images to PGM, PPM, BMP, TIFF or JPEG<br />
dcmmkdir: Create a DICOMDIR file<br />
举例：<br />
--用无失真JPEG压缩一幅DICOM图像文件。<br />
*****************************************************************************/<br />
DJEncoderRegistration::registerCodecs(); // register JPEG codecs<br />
DcmFileFormat fileformat;<br />
if (fileformat.loadFile(&quot;test.dcm&quot;).good())<br />
{<br />
DcmDataset *dataset = fileformat.getDataset();<br />
DcmItem *metaInfo = fileformat.getMetaInfo();<br />
DJ_RPLossless params; // codec parameters, we use the defaults<br />
// this causes the lossless JPEG version of the dataset to be created<br />
dataset-&gt;chooseRepresentation(EXS_JPEGProcess14SV1TransferSyntax, &#182;ms);<br />
// check if everything went well<br />
if (dataset-&gt;canWriteXfer(EXS_JPEGProcess14SV1TransferSyntax))<br />
{<br />
    // force the meta-header UIDs to be re-generated when storing the file<br />
    // since the UIDs in the data set may have changed<br />
    delete metaInfo-&gt;remove(DCM_MediaStorageSOPClassUID);<br />
    delete metaInfo-&gt;remove(DCM_MediaStorageSOPInstanceUID);<br />
    // store in lossless JPEG format<br />
    fileformat.saveFile(&quot;test_jpeg.dcm&quot;, EXS_JPEGProcess14SV1TransferSyntax);<br />
}<br />
}<br />
DJEncoderRegistration::cleanup(); // deregister JPEG codecs</pre>

<p>（详细的project配置如前一篇博文所述<a href="http://blog.csdn.net/zssureqh/article/details/38460445" rel="external nofollow noreferrer">http://blog.csdn.net/zssureqh/article/details/38460445</a>，在此就不在反复介绍了）</p>
<p>通过这段代码能够顺利实现对DCM图像的JPEG无损压缩。例如以下图所看到的，</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140811140829772"></p>
<p>利用Sante DICOM Editor专业DCM图像浏览编辑器打开压缩前后的图像，发现图像质量没有区别，压缩前实际大小为4572K，压缩后为1774K，压缩效果良好。</p>
<p><strong>&nbsp; &nbsp;设想：</strong>既然mDCM开源库就是对DCMTK开源库的封装，那么两个开源库中应该会有相相应的功能同样或类&#20284;的函数。有DCMTK实例中的代码可知，演示样例中仅仅调用了DcmFileFormat的loadFile、saveFile和DcmDataset的chooseRepresentation和canWriteXfer四个函数，并且从函数名称上看，就知道实际达到压缩效果的应该是DcmDataset的chooseRepresentation和canWriteXfer的两个函数，那么接下来我们看看mDCM开源库下的DcmDataset是否有相相应的函数呢？</p>
<p>通过VS2012的对象浏览器能够看到，mDCM开源库下的Dicom.Data命名空间中DcmDataset类中的确拥有一个类&#20284;的函数ChangeTransferSyntax，例如以下图：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140811140629078"></p>
<p><strong>&nbsp; &nbsp;推測：</strong>直接调用mDCM的Load、ChangeTransferSyntax和Save三个函数，应该能够实现与DCMTK同样的效果，即完毕对DCM的JPEG无损压缩。</p>
<p>详细代码例如以下，</p>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Text;<br />
using System.Threading.Tasks;<br />
using Dicom;<br />
using Dicom.Data;<br />
using Dicom.Codec;<br />
using Dicom.Codec.JpegLs;<br />
namespace JpegLossLess<br />
{<br />
    class Program<br />
    {<br />
        static void Main(string[] args)<br />
        {<br />
            DicomCodec.RegisterCodecs();<br />
            //Dicom.Codec.JpegLs.DcmJpegLsCodec.Register();<br />
            string fName = string.Format(&quot;d:\\dcm\\test.dcm&quot;);<br />
            DicomFileFormat ff = new DicomFileFormat();<br />
            ff.Load(fName, DicomReadOptions.Default | DicomReadOptions.DeferLoadingPixelData);<br />
            //ff.Load(fName, DicomReadOptions.None);<br />
            DcmPixelData pixels = new DcmPixelData(ff.Dataset);<br />
            DcmJpegLsParameters JpegParameters = new DcmJpegLsParameters();<br />
            ff.FileMetaInfo.TransferSyntax = DicomTransferSyntax.JPEGProcess14SV1;<br />
            ff.Dataset.ChangeTransferSyntax(DicomTransferSyntax.JPEGProcess14SV1, JpegParameters);<br />
            string OutFile = string.Format(@&quot;d:\dcm\outfile.dcm&quot;);<br />
            ff.Save(OutFile, DicomWriteOptions.Default);<br />
        }<br />
    }<br />
}</pre>

<p>project顺利编译成功，执行调试后，也相同出现了大小为1774K的文件，可是利用Sante DICOM Editor打开该文件时，出现错误，例如以下图所看到的：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140811140831847"></p>
<p>利用DCMTK开源库的工具包dcmdump.exe查看利用mDCM压缩后的文件outfile.dcm，输出例如以下错误提示：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140811140631062"></p>
<p>警告（Warning）提示(0008,0000)数据元素的数&#20540;有误，错误（Error）是出现了无法识别的标签和数据（f752,0e57），经过查看DICOM3.0标准，并未发现有（f752,0e57）该标签，利用UltraEdit打开DCMTK压缩后的文件test_jpeg.dcm和mDCM压缩的文件outfile.dcm，通过查找功能发现，(f752,0e57)字段实际上是标准的JPEG无损压缩后的(7fe0,0010)字段的Value Field内容（例如以下图所看到的），因此推測应该是mDCM压缩后的文件头中某个字段写入有误，导致在读取数据体的时候并未依照原本的DICOM3.0标准去读取。</p>
<h1>解决方法：</h1>
<p>利用DCMTK的project来读取我们利用mDCM压缩后的文件outfile.dcm，结果单步调试进入后，利用Load函数读取Jpeg压缩后的图像时，metainfo部分是没有问题的。可是当读取到dataset时，对于（0008,0000）元素的读取有误，正确的（0008,0000）元素的解析方式为</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140811140833641"></p>
<blockquote><blockquote><blockquote><p><strong>元素标签，即（group，element）为：08 00 00 00——（0008,0000）</strong></p></blockquote></blockquote>
<blockquote><blockquote><p><strong>元素类型，即VR为：55 4C——UL</strong></p></blockquote></blockquote>
<blockquote><blockquote><p><strong>元素长度，即VL为：04 00——0004（长度为4）</strong></p></blockquote></blockquote>
<blockquote><blockquote><p><strong>元素&#20540;域，即Value Field：B8 00 00 00——00000008（&#20540;为184）</strong></p></blockquote></blockquote></blockquote>
<p>可是在读取dataset时，将55 4c 04 00所有当成了长度来读取，因此<strong>推測</strong>是将<strong>原本为ExplicitUL&#26684;式的元素当做了ImplicitVR&#26684;式来读取了</strong>，文件流的指针_streamPosition直接从0x0000000000000160直接跳转到了0x0000000000044db5，例如以下图所看到的：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140811161508998"></p>
<p>因此尝试在mDCM的c#project中加入手动改动文件元信息中传输语义的语句，</p>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Text;<br />
using System.Threading.Tasks;<br />
using Dicom;<br />
using Dicom.Data;<br />
using Dicom.Codec;<br />
using Dicom.Codec.JpegLs;<br />
namespace JpegLossLess<br />
{<br />
    class Program<br />
    {<br />
        static void Main(string[] args)<br />
        {<br />
            /****************************************************<br />
            * 对照C++中DCMTK对于DICOM进行JPEG无损压缩，来学习C#<br />
            * 中Dicom库的使用<br />
            * 2014-08-06<br />
            * zssure<br />
            ****************************************************/<br />
            DicomCodec.RegisterCodecs();<br />
            string fName = string.Format(@&quot;d:\dcm\test.dcm&quot;);<br />
            DicomFileFormat ff = new DicomFileFormat();<br />
            ff.Load(fName, DicomReadOptions.Default | DicomReadOptions.DeferLoadingPixelData);<br />
            DcmJpegLsParameters JpegParameters = new DcmJpegLsParameters();<br />
            ff.FileMetaInfo.TransferSyntax = DicomTransferSyntax.JPEGProcess14SV1;<br />
            ff.Dataset.ChangeTransferSyntax(DicomTransferSyntax.JPEGProcess14SV1, JpegParameters);<br />
            string OutFile = string.Format(@&quot;d:\dcm\outfileJpeg22.dcm&quot;);<br />
            ff.Save(OutFile, DicomWriteOptions.Default);<br />
        }<br />
    }<br />
}</pre>

<p>project编译后，可以顺利完毕压缩DCM的功能，至此利用mDCM对DICOM图像进行JPEG无损压缩的目的已经实现。</p>
<h1>总结：</h1>
<p>DICOM3.0标准的第10部分中，有对于dcm文件存储&#26684;式的具体介绍，当中对于传输语义的介绍例如以下：</p>
<blockquote><p>1）Except for the 128 byte preamble and the 4 byte prefix, the <strong>File Meta Information</strong> shall be encoded using the<strong>Explicit VR Little Endian Transfer Syntax (UID=1.2.840.10008.1.2.1)</strong> as defined<br />
 in DICOM PS 3.5. Values of each File Meta Element shall be padded when necessary to achieve an even length, as specified in PS 3.5 by their corresponding Value Representation. The Unknown (UN) Value Representation shall not be used in the File Meta Information.<br />
 For compatibility with future versions of this Standard, any Tag (0002,xxxx) not defined in Table 7.1-1 shall be ignored. Values of all Tags (0002,xxxx) are reserved for use bythis Standard and later versions of DICOM. Data Elements with a group of 0002 shall<br />
 not be used in datasets other than within the File Meta Information</p>
<p>2）The Transfer Syntax used to encode the DataSet cannot be changed within the Data Set; i.e., the Transfer Syntax UID Data Element may not occur anywhere within the Data Set, e.g., nested within a Sequence Item.</p></blockquote>
<p>因此DCM文件元信息中的标签（0002,0010），即传输语义，对于DCM文件的数据体Dataset的读取起到关键的作用。通过此次的mDCM开源库与DCMTK开源库的比較发现，两者尽管大多的函数都同样，且名称和功能都类&#20284;，可是对于细节部分应该注意。</p>
<p>如今对两个开源库对DCM文件的JPEG无损压缩功能所须要调用的函数进行一个对照分析，以找到两者之间的区别所在，详细分析例如以下表</p>
<table>
<tbody>
<tr>
<td>
<p><strong>mDCM</strong></p>
</td>
<td>
<p><strong>DCMTK</strong></p>
</td>
</tr>
<tr>
<td>
<p>1） DicomFileFormat.Load，打开文件（也是通过文件流的方式一一读取DCM文件的各个信息到内存中）</p>
<p>2） DicomFileFormat.Dataset.ChangeTransferSyntax，该函数与DCMTK中的chooseRepresentation函数类&#20284;，在參数中都须要指出新的传输语义，函数内部会依据新的传输语义来改动数据体的存储方式。该函数主要完毕的功能是：</p>
<p>比較新旧传输语义、依据新旧语义决定数据体是否解压缩或压缩（Dicom.Codec.Encode或者Dicom.Codec.Decode）。</p>
<p>3） DicomFileFormat.Save，存储文件，可是该函数中并不须要填写新的传输语义</p>
<p><strong>【注】：这一点与DCMTK中的saveFile函数不同。这也就是上个周C#版本号的mDCM实现对DCM数据的JPEG无损压缩后无法顺利读取的原因。由于数据体存储&#26684;式不是依照文件元信息中指定的传输语义存储的，或者说文件元信息中的传输语义没有改动为JPEG无损压缩的方式。</strong></p>
</td>
<td>
<p>1） DicomFileFormat::loadFile，导入文件，主要是DcmMetaInfo和DcmDataset两部分；</p>
<p>2） Dataset::chooseReresentation，參数中会出现新旧传输语义TransferSyntax，函数依据新的语义对对应数据（主要是像素数据）进行处理，会调用DcmPixelData::canChooseRepresentation、DcmPixelData::chooseRepresentation</p>
<p>3） Dataset::canWriteXfer，參数中是新改动后的传输语义。</p>
<p>4） DcmFileFormat::saveFile，參数中须要指出改动后的传输语义。</p>
<p><strong>——》</strong>随后会调用dcfilefo.cc文件里的validateMetaInfo函数（该函数中也须要指定新的传输语义）。</p>
<p><strong>——》</strong>对文件元信息的各个元素分别调用DcmMetaInfo::search和chekMetaHeaderValue两个函数（在该函数内，会检測各个元信息元素是否存在，不存在会新建之并插入，其參数中就须要指出新的传输语义）</p>
<p><strong>——》</strong>DcmElement::putString将新的传输协议写入到MetaInfo中。（基本调用流程例如以下图。</p>
</td>
</tr>
</tbody>
</table>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20140811161308109"></div>
<p><strong>作者：</strong><a href="zssure@163.com" rel="external nofollow noreferrer"><strong>zssure@163.com</strong></a></p>
<p><strong>时间：2014-08-11</strong></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwownr9.html">Python系统命令操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o0l058.html">Notification NotificationManager RemoteViews PendingIntent</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8omzn5q.html">Azure 上为Liunx VM 挂载File类型的存储。</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m3yv09.html">开始学习node&period;js了，第一节，fs文件系统 【fs&period;rename】重命名文件&sol;文件夹</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmd2749.html">IOS&lowbar;设置启动图片若干问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1y3wk8.html">UVa 10561 &lpar;SG函数 递推&rpar; Treblecross</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1xoz39.html">&lbrack;dp&rsqb;POJ2559 &amp;amp&semi;&amp;amp&semi; HDOJ1506 Largest Rectangle in a Histogram</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmkpe09.html">《ArcGIS Engine&plus;C&num;实例开发教程》第四讲 状态栏信息的添加与实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j06opwq.html">我的接口框架---框架函数文件common&period;php</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x2e7g9.html">&lbrack;个人原创&rsqb;关于java中对象排序的一些探讨（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yeyg0q.html">几家SIEM</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rggkwm8.html">ListView的操作模式的选择的更详细的解释CHOICE&lowbar;MODE&lowbar;MULTIPLE与CHOICE&lowbar;MODE&lowbar;MULTIPLE&lowbar;MODAL</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv11ywxq.html">CSS hack方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj2dd38.html">剑指前端（前端入门笔记）&mdash;&mdash;Date类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyvjkx9.html">借助FreeHttp任意篡改http报文 （使用&amp;&num;183&semi;实现）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwyevd8.html">ubuntu 14&period;04 软件中心闪退解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvey0l8.html">plsql developer导入导出序列方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1kkv09.html">WINDOWS平台下的栈溢出攻击从0到1（篇幅略长但非常值得一看）</a>
		</li>
						<li><a href="https://www.batexi.com/a/902vxz4q.html">使用CSS3改变文本选中的默认颜色</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pyxr0q.html">Luogu2482 &lbrack;SDOI2010&rsqb;猪国杀 ---- 模拟</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxknj0v8.html">iOS文件保存策略</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gemynz8.html">python语言学习5&mdash;&mdash;输入和输出</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jwlx38.html">appium简明教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljm6r69.html">MongoDB--Getting Started with Java Driver</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgdvjm8.html">ACM-简单题之Least Common Multiple&mdash;&mdash;hdu1019</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgdegr8.html">getline与get函数的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgdo5r8.html">linux su&comma;sudo命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgdo3d8.html">《Linux设备驱动开发具体解释&lpar;第3版&rpar;》进展同步更新</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljmy209.html">Linux 文件系统&lpar;二&rpar;---运行过程及结构间的关系</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkn0y08.html">Quartz时间配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
